#!/usr/bin/env python
import sys, re, os

base_re = re.compile('base_graphics +spr([1-9][0-9]+) *\\(')
alt_re = re.compile('alternative_sprites *\\( *spr([1-9][0-9]+), *ZOOM_LEVEL_NORMAL')

spr_labels = 0
alt_labels = 0

exclude = """\
./sprites/base/base-0000-font.pnml
./sprites/base/base-0674-gui.pnml
./sprites/base/base-0771-recolor.pnml
./sprites/base/base-0805-faces.pnml
./sprites/base/base-4077-gui-toolbar-pointer.pnml
./sprites/base/base-4297-gui-cargo-icons.pnml
./sprites/base/base-4790-gui-buy-land.pnml
./sprites/extra/extra-chars.pnml
./sprites/extra/extra-openttd-flags.pnml
./sprites/extra/extra-openttd-gui.pnml
./sprites/logos/logos-0011-highscore.pnml
./sprites/logos/logos-0021-newspaper-2051.pnml
./sprites/logos/logos-0031-tycoon-of-century.pnml
./sprites/logos/logos-0043-intro-letters.pnml
./sprites/logos/logos-0052-original-map-generator.pnml
./sprites/logos/logos-0089-gui-clima.pnml
./sprites/toyland/toyland-0885-gui.pnml
./sprites/toyland/toyland-1178-gui-recolor.pnml
./sprites/tropical/tropical-0555-gui-road-palm.pnml
""".split()

for dirpath, dirnames, filenames in os.walk('.'):
    for f in filenames:
        fpath = os.path.join(dirpath, f).lower()
        if not fpath.endswith('.pnml'): continue
        if fpath in exclude: continue

        fp = open(fpath, 'rt')
        n_spr, n_alts = 0, 0
        for line in fp:
            m = base_re.match(line)
            if m:
                num = int(m.group(1), 10)
                n_spr = n_spr + 1
            m = alt_re.match(line)
            if m:
                num = int(m.group(1), 10)
                n_alts = n_alts + 1
        fp.close()
        text = "%3d labels, %3d alternative graphics: %s" % (n_spr, n_alts, fpath)
        if n_spr == n_alts:
            while len(text) < 100: text = text + " "
            text = text + "DONE"
        print text
        alt_labels = alt_labels + n_alts
        spr_labels = spr_labels + n_spr

if spr_labels != 0:
    perc = 100.0 * alt_labels / spr_labels
    print "Score: %d labels, %d alternative labels, %.2f%% covered" % (spr_labels, alt_labels, perc)
else:
    print "No sprites found"

